/*-----------------------------------------------------------------------------
 * load.c for EmuZ-2000 ver0.02 Copyright (c) 2002 TSUNEOKA shinji
 *
 * Based tapeload.cpp ver0.13a Copyright (c) 1999-2000 Takeshi Maruyama
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-----------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include <mmsystem.h>

#define BIT_L				0
#define BIT_H				1
#define MZ_1200				7
#define MZ_2000				4
#define THRESHOLD_BASE		0x80
#define TONE_HEADER			0x2828
#define TONE_BODY			0x1414

#define DEFAULT_AUTO		FALSE
#define DEFAULT_REVERSE		FALSE
#define DEFAULT_BITSAVE		FALSE
#define DEFAULT_DISPLAYBITS	FALSE
#define DEFAULT_DISPLAYDUMP	FALSE
#define DEFAULT_SJIS		FALSE
#define DEFAULT_DEBUG		FALSE
#define DEFAULT_DATFILE		FALSE
#define DEFAULT_HOLD		BIT_L
#define DEFAULT_WAIT		MZ_2000
#define DEFAULT_THRESHOLD	32

/* }bvht@CǗ */
typedef struct tagMAPPING {
	LPSTR	lpszFile;		/* f[^w|C^ */
	DWORD	dwFileSize;		/* f[^TCY */
	HANDLE	hFile;			/* t@Cnh */
	HANDLE	hMap;			/* }bsOnh */
} MAPPING;
typedef MAPPING *LPMAPPING;

/* IvV */
typedef struct tagOPTIONS {
	char	szWaveFile[MAX_PATH];	/* Wavet@C */
	char	szOutFile[MAX_PATH];	/* o̓t@CgqȂ */
	char	szHeaderFile[MAX_PATH];	/* MZe[vwb_o̓t@C */
	char	szBodyFile[MAX_PATH];	/* MZe[v{̏o̓t@C */
	char	szMztFile[MAX_PATH];	/* MZTo̓t@C */
	LPBYTE	lpbData;				/* f[^擪 */
	LPBYTE	lpbTail;				/* f[^I[ */
	int 	iWait;					/* -w */
	int 	iThreshold;				/* -d */
	int 	iHold;					/* -1 */
	BOOL	fBitSave;				/* -s */
	BOOL	fReverse;				/* -r */
	BOOL	fDisplayBits;			/* -b */
	BOOL	fDisplayDump;			/* -v */
	BOOL	fDatFile;				/* -F */
	BOOL	fAuto;					/* -a */
} OPTIONS;
typedef OPTIONS *LPOPTIONS;

#pragma pack(1)
/* 1oCgE */

/* `N */
#define CHUNKIDLEN	4
typedef struct tagCHUNK {
	char	cId[CHUNKIDLEN];			/* `N̎ */
	DWORD	dwSize;						/* `ÑTCY */
} CHUNK;
typedef CHUNK *LPCHUNK;

/* MZe[vwb_ */
#define MZFILENAMELEN	17
#define MZHEADRESLEN	104
typedef struct tagMZTAPEHEADER {
	BYTE	bMode;						/* 0x01:@B 0x02:BASIC */
	char	szFileName[MZFILENAMELEN];	/* t@C */
	WORD	wSize;						/* f[^TCY */
	WORD	wStartAddress;				/* JnAhX */
	WORD	wJumpAddress;				/* sAhX */
	BYTE	bReserverd[MZHEADRESLEN];	/* \ */
} MZTAPEHEADER;
typedef MZTAPEHEADER *LPMZTAPEHEADER;

/* MZe[v{ */
#define MZBODYDATALEN	64*1024
typedef struct tagMZTAPEBODY {
	DWORD	dwSize;						/* f[^TCY */
	BYTE	bBody[MZBODYDATALEN];		/* {́Fő64KB */
} MZTAPEBODY;
typedef MZTAPEBODY *LPMZTAPEBODY;

/* MZe[v */
typedef struct tagMZTAPE {
	MZTAPEHEADER	header;				/* wb_ */
	MZTAPEBODY		body;				/* { */
} MZTAPE;
typedef MZTAPE *LPMZTAPE;

#pragma pack()
